#---
# Excerpted from "The ThoughtWorks Anthology 2",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/twa2 for more book information.
#---
class Spider
  def crawl_walls
    "crawling..."
  end
end
class Person
  # empty class
end
def make_crawl(obj) # no type constraints on obj
  if obj.respond_to? :crawl_walls
    puts obj.crawl_walls
  else
    puts "cannot crawl walls"
  end
end

peter = Person.new
def peter.crawl_walls
  "Look, Ma! I can crawl walls!"
end
make_crawl(Spider.new) #=> crawling...
make_crawl(Person.new) #=> cannot crawl walls
make_crawl(peter) #=> Look, Ma! I can crawl walls!
